<template>
    <div class="list-view">
        <div class="filters-container">
            <el-input placeholder="输入关键字" v-model="search" clearable class="filter-item"></el-input>
            <el-button @click="getData" type="primary" icon="el-icon-search" class="filter-item">搜索 </el-button>
            <!-- <el-button
                @click="download"
                type="primary"
                icon="el-icon-download"
                :loading="downloading"
                class="filter-item"
                >导出EXCEL
            </el-button> -->
            <el-select
                v-model="companyId"
                placeholder="请选择公司"
                clearable
                filterable
                @change="getData"
                v-if="display"
            >
                <el-option v-for="item in companies" :key="item.id" :value="item.id" :label="item.name"></el-option>
            </el-select>
        </div>
        <el-table
            :data="tableData"
            row-key="id"
            ref="table"
            height="tableHeight"
            header-row-class-name="table-header-row"
            header-cell-class-name="table-header-cell"
            row-class-name="table-row"
            cell-class-name="table-cell"
        >
            <el-table-column v-if="multipleMode" align="center" type="selection" width="50"> </el-table-column>
            <!--<el-table-column prop="id" label="ID" width="100"> </el-table-column>-->
            <el-table-column prop="username" label="用户名" min-width="80"> </el-table-column>
            <el-table-column prop="nickname" label="昵称" min-width="80"> </el-table-column>
            <el-table-column label="头像" min-width="80">
                <template slot-scope="{ row }">
                    <el-image
                        style="width: 30px; height: 30px;"
                        :src="row.avatar"
                        fit="cover"
                        :preview-src-list="[row.avatar]"
                    ></el-image>
                </template>
            </el-table-column>
            <el-table-column prop="amount" label="余额">
                <!-- <template slot-scope="{ row }">
                    <span>{{ row.amount }}</span>
                    <i class="el-icon-user-solid" v-if="row.teamFounder"></i>
                </template> -->
            </el-table-column>
            <el-table-column prop="company.name" label="企业名称" show-overflow-tooltip> </el-table-column>
            <el-table-column label="操作" align="center" fixed="right">
                <template slot-scope="{ row }">
                    <el-button
                        @click="remove(row)"
                        type="warning"
                        size="mini"
                        plain
                        :loading="$store.state.fetchingData"
                        v-if="!row.teamFounder"
                    >
                        移除
                    </el-button>
                </template>
            </el-table-column>
        </el-table>
        <div class="pagination-wrapper">
            <el-pagination
                background
                @size-change="onSizeChange"
                @current-change="onCurrentChange"
                :current-page="page"
                :page-sizes="[10, 20, 30, 40, 50]"
                :page-size="pageSize"
                layout="total, sizes, prev, pager, next, jumper"
                :total="totalElements"
            >
            </el-pagination>
        </div>
    </div>
</template>
<script>
import { mapState } from 'vuex';
import pageableTable from '@/mixins/pageableTable';
export default {
    mixins: [pageableTable],
    data() {
        return {
            multipleMode: false,
            search: '',
            url: '/user/myEmployee',
            downloading: false,
            companyId: '',
            companies: [],
            display: false
        };
    },
    created() {
        if (this.$route.query.id) {
            this.companyId = this.$route.query.id;
        }
        this.$http
            .get('/company/allList')
            .then(res => {
                this.companies = res;
            })
            .catch(e => {
                console.log(e);
            });
        this.getAdmin();
    },
    computed: {
        ...mapState(['userInfo']),
        selection() {
            return this.$refs.table.selection.map(i => i.id);
        }
    },
    methods: {
        beforeGetData() {
            return {
                search: this.search,
                query: {
                    companyId: this.companyId || this.$route.query.id
                }
            };
        },
        toggleMultipleMode(multipleMode) {
            this.multipleMode = multipleMode;
            if (!multipleMode) {
                this.$refs.table.clearSelection();
            }
        },
        addRow() {
            this.$router.push({
                path: '/userEdit',
                query: {
                    ...this.$route.query
                }
            });
        },
        editRow(row) {
            this.$router.push({
                path: '/userEdit',
                query: {
                    id: row.id
                }
            });
        },
        download() {
            this.downloading = true;
            this.$axios
                .get('/user/excel', { responseType: 'blob' })
                .then(res => {
                    console.log(res);
                    this.downloading = false;
                    const downloadUrl = window.URL.createObjectURL(new Blob([res.data]));
                    const link = document.createElement('a');
                    link.href = downloadUrl;
                    link.setAttribute('download', res.headers['content-disposition'].split('filename=')[1]);
                    document.body.appendChild(link);
                    link.click();
                    link.remove();
                })
                .catch(e => {
                    console.log(e);
                    this.downloading = false;
                    this.$message.error(e.error);
                });
        },
        operation1() {
            this.$notify({
                title: '提示',
                message: this.selection
            });
        },
        operation2() {
            this.$message('操作2');
        },
        remove(row) {
            this.$alert('确认该员工移除' + row.company.name + '么？', '提示', { type: 'primary' })
                .then(() => {
                    return this.$http.post('/company/removeEmp', {
                        userId: row.id,
                        companyId: row.companyId
                    });
                })
                .then(() => {
                    this.$message.success('移除成功');
                    history.go(0);
                })
                .catch(action => {
                    if (action === 'cancel') {
                        this.$message.info('移除取消');
                    } else {
                        this.$message.error('移除失败');
                        console.log(action);
                    }
                });
        },
        getAdmin() {
            let data = this.userInfo.authorities;
            for (let item in data) {
                if (data[item].name === 'ROLE_ADMIN') {
                    this.display = true;
                    break;
                }
            }
        }
    }
};
</script>
<style lang="less" scoped></style>
